Subject: Re: linux-next: manual merge of the audit tree with the powerpc tree

From: Christophe Leroy <[email-masked]>
Date: Thu, 16 Dec 2021 09:08:13 +0000

Le 14/12/2021 à 21:30, Cédric Le Goater a écrit :
> On 12/14/21 20:32, Christophe Leroy wrote:
>>
>>
>> Le 14/12/2021 à 19:23, Paul Moore a écrit :
>>> On Tue, Dec 14, 2021 at 12:59 PM Christophe Leroy
>>> <[email-masked]> wrote:
>>>> Hello Paul,
>>>>
>>>> I've been trying to setup your test suite on my powerpc board but it's
>>>> based on Perl and on a lot of optional Perl packages. I was able to add
>>>> them one by one until some of them require some .so libraries
>>>> (Pathtools-Cwd), and it seems nothing is made to allow cross building
>>>> those libraries.
>>>>
>>>> Do you have another test suite based on C and not perl ?
>>>>
>>>> If not, what can I do, do you know how I can cross compile those Perl
>>>> packages for PPC32 ?
>>>
>>> Is there no Linux distribution that supports PPC32?  I would think
>>> that would be the easiest path forward, but you're the PPC32 expert -
>>> not me - so I'll assume you already tried that or it didn't work for
>>> other reasons.
>>
>> There hasn't been Linux distribution supporting PPC32 for a few years
>> now. And regardless, the boards I'm running Linux on are home made
>> embedded boards, with limited amount of memory and flashdisk space and
>> no video chip, so they are hardly supported by any distributions, even
>> older ones.
> 
> We still have debian. you will find images under :
> 
>    https://cdimage.debian.org/cdimage/ports/snapshots/2021-04-17/
> 
> and from there, you can update to unstable, which runs fine under
> a mac99 QEMU machine.
> 

Thanks Cédric, I've now been able to install debian PPC32 port of DEBIAN 
11 on QEMU and run the tests.

I followed instructions in file README.md provided in the test suite.
I also modified tests/Makefile to force MODE := 32

I've got a lot of failures, am I missing some options in the kernel or 
something ?

Running as   user    root
         with context root:::
         on   system

# Test 3 got: "256" (backlog_wait_time_actual_reset/test at line 151)
#   Expected: "0"
#  backlog_wait_time_actual_reset/test line 151 is: ok( $result, 0 ); 
  # Was an event found?
# Test 4 got: "0" (backlog_wait_time_actual_reset/test at line 168)
#   Expected: "1"
#  backlog_wait_time_actual_reset/test line 168 is: ok( $found_msg, 1 ); 
    # Was the message well-formed?
# Failed test 5 in backlog_wait_time_actual_reset/test at line 169
#  backlog_wait_time_actual_reset/test line 169 is: ok( $reset_rc == 
$reset_msg )
backlog_wait_time_actual_reset/test ..
Failed 3/5 subtests
sh: 1: Syntax error: Bad fd number
sh: 1: Syntax error: Bad fd number
exec_execve/test ..................... ok
sh: 1: Syntax error: Bad fd number
sh: 1: Syntax error: Bad fd number
# Failed test 7 in exec_name/test at line 145 fail #4
#  exec_name/test line 145 is:         ok( $found[$_] == $expected[$_] );
sh: 1: Syntax error: Bad fd number
# Failed test 11 in exec_name/test at line 145 fail #7
sh: 1: Syntax error: Bad fd number
# Failed test 15 in exec_name/test at line 145 fail #10
# Failed test 17 in exec_name/test at line 145 fail #12
sh: 1: Syntax error: Bad fd number
# Failed test 19 in exec_name/test at line 145 fail #13
sh: 1: Syntax error: Bad fd number
# Failed test 23 in exec_name/test at line 145 fail #16
# Failed test 24 in exec_name/test at line 145 fail #17
sh: 1: Syntax error: Bad fd number
Error sending add rule data request (Rule exists)
# Failed test 29 in exec_name/test at line 145 fail #21
sh: 1: Syntax error: Bad fd number
exec_name/test .......................
Failed 8/29 subtests
sh: 1: Syntax error: Bad fd number
# Failed test 2 in file_create/test at line 121
#  file_create/test line 121 is: ok($found_syscall);
# Failed test 3 in file_create/test at line 122
#  file_create/test line 122 is: ok($found_parent);
# Failed test 4 in file_create/test at line 123
#  file_create/test line 123 is: ok($found_create);
sh: 1: Syntax error: Bad fd number
file_create/test .....................
Failed 3/4 subtests
sh: 1: Syntax error: Bad fd number
# Failed test 2 in file_delete/test at line 122
#  file_delete/test line 122 is: ok($found_syscall);
# Failed test 3 in file_delete/test at line 123
#  file_delete/test line 123 is: ok($found_parent);
# Failed test 4 in file_delete/test at line 124
#  file_delete/test line 124 is: ok($found_delete);
sh: 1: Syntax error: Bad fd number
file_delete/test .....................
Failed 3/4 subtests
sh: 1: Syntax error: Bad fd number
# Failed test 2 in file_rename/test at line 138
#  file_rename/test line 138 is: ok($found_syscall);
# Test 3 got: "0" (file_rename/test at line 139)
#   Expected: "2"
#  file_rename/test line 139 is: ok( $found_parent, 2 );
# Failed test 4 in file_rename/test at line 140
#  file_rename/test line 140 is: ok($found_create);
# Failed test 5 in file_rename/test at line 141
#  file_rename/test line 141 is: ok($found_delete);
sh: 1: Syntax error: Bad fd number
file_rename/test .....................
Failed 4/5 subtests
sh: 1: Syntax error: Bad fd number
# Test 1 got: "256" (filter_exclude/test at line 60)
#   Expected: "0"
#  filter_exclude/test line 60 is: ok( $result, 0 );
Use of uninitialized value $subj in scalar chomp at filter_exclude/test 
line 62.
Use of uninitialized value $subj in pattern match (m//) at 
filter_exclude/test line 63.
Use of uninitialized value $subj_user in concatenation (.) or string at 
filter_exclude/test line 86.
-F missing value after operation for subj_user
# Test 7 got: "65280" (filter_exclude/test at line 87)
#   Expected: "0"
#  filter_exclude/test line 87 is: ok( $result, 0 );
Use of uninitialized value $subj_user in concatenation (.) or string at 
filter_exclude/test line 88.
-F missing value after operation for subj_user
Use of uninitialized value $subj_role in concatenation (.) or string at 
filter_exclude/test line 89.
-F missing value after operation for subj_role
# Test 8 got: "65280" (filter_exclude/test at line 90)
#   Expected: "0"
#  filter_exclude/test line 90 is: ok( $result, 0 );
Use of uninitialized value $subj_role in concatenation (.) or string at 
filter_exclude/test line 91.
-F missing value after operation for subj_role
Use of uninitialized value $subj_type in concatenation (.) or string at 
filter_exclude/test line 92.
-F missing value after operation for subj_type
# Test 9 got: "65280" (filter_exclude/test at line 93)
#   Expected: "0"
#  filter_exclude/test line 93 is: ok( $result, 0 );
Use of uninitialized value $subj_type in concatenation (.) or string at 
filter_exclude/test line 94.
-F missing value after operation for subj_type
Use of uninitialized value $subj_sen in concatenation (.) or string at 
filter_exclude/test line 95.
-F missing value after operation for subj_sen
# Test 10 got: "65280" (filter_exclude/test at line 96)
#    Expected: "0"
#  filter_exclude/test line 96 is: ok( $result, 0 );
Use of uninitialized value $subj_sen in concatenation (.) or string at 
filter_exclude/test line 97.
-F missing value after operation for subj_sen
Use of uninitialized value $subj_clr in concatenation (.) or string at 
filter_exclude/test line 98.
-F missing value after operation for subj_clr
# Test 11 got: "65280" (filter_exclude/test at line 99)
#    Expected: "0"
#  filter_exclude/test line 99 is: ok( $result, 0 );
Use of uninitialized value $subj_clr in concatenation (.) or string at 
filter_exclude/test line 100.
-F missing value after operation for subj_clr
Use of uninitialized value $subj_user in concatenation (.) or string at 
filter_exclude/test line 113.
Use of uninitialized value $subj_role in concatenation (.) or string at 
filter_exclude/test line 113.
Use of uninitialized value $subj_type in concatenation (.) or string at 
filter_exclude/test line 113.
Use of uninitialized value $subj_sen in concatenation (.) or string at 
filter_exclude/test line 113.
Use of uninitialized value $subj_clr in concatenation (.) or string at 
filter_exclude/test line 113.
-F missing value after operation for subj_user
# Test 15 got: "65280" (filter_exclude/test at line 116)
#    Expected: "0"
#  filter_exclude/test line 116 is: ok( $result, 0 );
Use of uninitialized value $subj in concatenation (.) or string at 
filter_exclude/test line 135.
Use of uninitialized value $subj_user in concatenation (.) or string at 
filter_exclude/test line 147.
Use of uninitialized value $subj_role in concatenation (.) or string at 
filter_exclude/test line 147.
Use of uninitialized value $subj_type in concatenation (.) or string at 
filter_exclude/test line 147.
Use of uninitialized value $subj_sen in concatenation (.) or string at 
filter_exclude/test line 147.
Use of uninitialized value $subj_clr in concatenation (.) or string at 
filter_exclude/test line 147.
-F missing value after operation for subj_user
# Test 19 got: "65280" (filter_exclude/test at line 150)
#    Expected: "0"
#  filter_exclude/test line 150 is: ok( $result, 0 );
Use of uninitialized value $subj in concatenation (.) or string at 
filter_exclude/test line 164.
# Test 20 got: "256" (filter_exclude/test at line 167)
#    Expected: "0"
#  filter_exclude/test line 167 is: ok( $result, 0 );
# Test 21 got: "0" (filter_exclude/test at line 179)
#    Expected: "1"
#  filter_exclude/test line 179 is: ok( $found_msg, 1 );
sh: 1: Syntax error: Bad fd number
filter_exclude/test ..................
Failed 10/21 subtests
sh: 1: cannot create /dev/udp/127.0.0.1/24242: Directory nonexistent
# Test 3 got: "256" (filter_saddr_fam/test at line 88)
#   Expected: "0"
#  filter_saddr_fam/test line 88 is: ok( $result, 0 );    # Was an event 
found?
# Test 4 got: "0" (filter_saddr_fam/test at line 129)
#   Expected: "1"
#  filter_saddr_fam/test line 129 is: ok( $found_msg,    1 );     # Was 
the inet message found?
filter_saddr_fam/test ................
Failed 2/5 subtests
sh: 1: Syntax error: Bad fd number
sh: 1: Syntax error: Bad fd number
filter_sessionid/test ................ ok
sh: 1: Syntax error: Bad fd number
sh: 1: Syntax error: Bad fd number
login_tty/test ....................... ok
# Test 3 got: "256" (lost_reset/test at line 150)
#   Expected: "0"
#  lost_reset/test line 150 is: ok( $result, 0 );    # Was an event found?
# Test 4 got: "0" (lost_reset/test at line 167)
#   Expected: "1"
#  lost_reset/test line 167 is: ok( $found_msg, 1 );              # Was 
the message well-formed?
# Failed test 5 in lost_reset/test at line 168
#  lost_reset/test line 168 is: ok( $reset_rc == $reset_msg );    # Do 
the two lost values agree?
lost_reset/test ......................
Failed 3/5 subtests
sh: 1: Syntax error: Bad fd number
sh: 1: cannot create /dev/udp/127.0.0.1/42424: Directory nonexistent
sh: 1: cannot create /dev/udp/::1/42424: Directory nonexistent
sh: 1: cannot create /dev/tcp/127.0.0.1/42424: Directory nonexistent
sh: 1: cannot create /dev/tcp/::1/42424: Directory nonexistent
# Failed test 4 in netfilter_pkt/test at line 144 fail #3
#  netfilter_pkt/test line 144 is:     ok( $found[$_] );    # Was the 
nfmarked parcket found?
# Failed test 5 in netfilter_pkt/test at line 144 fail #4
# Failed test 6 in netfilter_pkt/test at line 144 fail #5
# Failed test 7 in netfilter_pkt/test at line 144 fail #6
# Failed test 10 in netfilter_pkt/test at line 148 fail #3
#  netfilter_pkt/test line 148 is:     ok( $fields[$_] == $fields ); 
# $_ Correct number of fields?
# Failed test 11 in netfilter_pkt/test at line 148 fail #4
# Failed test 12 in netfilter_pkt/test at line 148 fail #5
# Failed test 13 in netfilter_pkt/test at line 148 fail #6
sh: 1: Syntax error: Bad fd number

Thanks
Christophe